<?php
/**
* @version      2.5.2 16.11.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerConfig extends JController{
    
    function __construct( $config = array() ){
        parent::__construct( $config );

        $this->registerTask( 'apply', 'save' );
    }

    function display(){
        
        $jshopConfig = &JSFactory::getConfig();        
        $current_currency = &JTable::getInstance('currency', 'jshop');
        $current_currency->load($jshopConfig->mainCurrency);
        if ($current_currency->currency_value!=1){
            JError::raiseWarning("",_JSHOP_ERROR_MAIN_CURRENCY_VALUE);    
        }
               
        $view=&$this->getView("configpanel", 'html'); 
        $view->display();
    }
    
    function general(){
    
	    $jshopConfig = &JSFactory::getConfig();
		$db = &JFactory::getDBO();
        $lists['languages'] = JHTML::_('select.genericlist', getAllLanguages(), 'defaultLanguage', 'class = "inputbox" size = "1"', 'language', 'name', $jshopConfig->defaultLanguage);
         
    	$view=&$this->getView("config", 'html');
        $view->setLayout("general");
		$view->assign("lists", $lists); 
        $view->display();
    }
    
    function catprod(){  
            
        $view=&$this->getView("config", 'html');
        $view->setLayout("categoryproduct");
        $view->display();
    }
    
    function checkout(){  
         
        $jshopConfig = &JSFactory::getConfig();
        $_orders = &$this->getModel("orders");
        $order_status = $_orders->getAllOrderStatus();
        $lists['status'] = JHTML::_('select.genericlist', $order_status,'default_status_order','class = "inputbox" size = "1"','status_id','name', $jshopConfig->default_status_order);   
        
        $view=&$this->getView("config", 'html');
        $view->setLayout("checkout");
        $view->assign("lists", $lists); 
        $view->display();
    }
    
    function adminfunction(){  
            
        $view=&$this->getView("config", 'html');
        $view->setLayout("adminfunction");
        $view->display();
    }
    
    function currency(){
    	$jshopConfig = &JSFactory::getConfig();
		$db = &JFactory::getDBO();
		$_currencies = &$this->getModel("currencies");
		$currencies = $_currencies->getAllCurrencies();
		
		$lists['currencies'] = JHTML::_('select.genericlist', $currencies,'mainCurrency','class = "inputbox" size = "1"','currency_id','currency_name',$jshopConfig->mainCurrency);
		
		$i = 0;
		foreach ($jshopConfig->format_currency as $key => $value) {
			$currenc[$i]->id_cur = $key;
			$currenc[$i]->format = $value;
			$i++;
		}
		$lists['format_currency'] = JHTML::_('select.genericlist', $currenc,'currency_format','class = "inputbox" size = "1"','id_cur','format',$jshopConfig->currency_format);
				
        $view=&$this->getView("config", 'html');
        $view->setLayout("currency");
		$view->assign("lists", $lists); 
        $view->display();
		
    }
    
    function image(){
    	
    	$view=&$this->getView("config", 'html');
        $view->setLayout("image");
        $view->display();
    }
    
    function mainpage(){
    
    	$_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        $multilang = count($languages)>1;
	    
	    $db = &JFactory::getDBO();
		$query = "SELECT * FROM `#__jshopping_config_main_page` AS main_page";
		$db->setQuery($query);
		$_rows = $db->loadObjectList();
	    
	    $rows = array();
	    foreach($_rows as $row){
            JFilterOutput::objectHTMLSafe( $row, ENT_QUOTES);
	        $rows[$row->language] = $row;
	    }
    	    	
        $view=&$this->getView("config", 'html');
        $view->setLayout("text");
		$view->assign("descr", $rows);
        $view->assign('languages', $languages);
        $view->assign('multilang', $multilang); 
        $view->display();
    }
    
    function storeinfo(){
    	$jshopConfig = &JSFactory::getConfig();
    	$_countries = &$this->getModel("countries");
		$countries = $_countries->getAllCountries(0);	
	    $first = JHTML::_('select.option', 0,_JSHOP_SELECT,'country_id','name' );
		array_unshift($countries,$first);
		$lists['countries'] = JHTML::_('select.genericlist', $countries,'store_country','class = "inputbox" size = "1"','country_id','name',$jshopConfig->store_country);
		
    	$view=&$this->getView("config", 'html');
        $view->setLayout("storeinfo");
		$view->assign("lists", $lists); 
        $view->display();
    }
    
    function save(){

	    $jshopConfig = &JSFactory::getConfig();
		$tab = JRequest::getVar('tab');
		$db = &JFactory::getDBO();
		
		$post = JRequest::get("post");
	
		$array = array('use_rabatt_code','enable_wishlist', 'shop_user_guest','user_as_catalog');
		if ($tab == 1){
			foreach ($array as $key => $value) {
				if (!isset($post[$value])) $post[$value] = 0;
			}	
		}
        
        $array = array('show_buy_in_category','show_tax_in_product','show_tax_product_in_cart','show_plus_shipping_in_product','hide_product_not_avaible_stock','hide_buy_not_avaible_stock','show_sort_product','show_count_select_products','show_delivery_time','demo_type','product_show_manufacturer_logo','product_show_weight',
                       'product_attribut_first_value_empty', 'show_hits', 'allow_reviews_prod', 'allow_reviews_only_registered','hide_text_product_not_available','use_plugin_content');
        if ($tab == 6){
            foreach ($array as $key => $value) {
                if (!isset($post[$value])) $post[$value] = 0;
            }    
        }
        
        $array = array('without_shipping','without_payment','order_send_pdf_client','order_send_pdf_admin','hide_tax', 'show_registerform_in_logintemplate','sorting_country_in_alphabet','show_weight_order', 'discount_use_full_sum','show_cart_all_step_checkout');
        if ($tab == 7){
            foreach ($array as $key => $value) {
                if (!isset($post[$value])) $post[$value] = 0;
            }    
        }
        
        $array = array('admin_show_product_basic_price','admin_show_attributes','admin_show_delivery_time','admin_show_languages','use_different_templates_cat_prod','admin_show_product_video','admin_show_product_related','admin_show_product_files','admin_show_product_bay_price','admin_show_product_basic_price', 'admin_show_product_labels');
        if ($tab == 8){
            foreach ($array as $key => $value) {
                if (!isset($post[$value])) $post[$value] = 0;
            }    
        }

        if ($tab != 4){
		    $config = new jshopConfig($db);
		    $config->id = 1;
		    if(!$config->bind($post)) {
			    JError::raiseWarning("",_JSHOP_ERROR_BIND);
			    $this->setRedirect('index.php?option=com_jshopping&controller=config');
			    return 0;
		    }
		    
		    $config->transformPdfParameters();				
        	    
		    if(!$config->store()) {
			    JError::raiseWarning("",_JSHOP_ERROR_SAVE_DATABASE." ".$config->_error);
			    $this->setRedirect('index.php?option=com_jshopping&controller=config');
			    return 0;
		    }
        }
		
		if (isset($_FILES['header'])){
			if ($_FILES['header'][size]){
				@unlink($jshopConfig->path . "images/header.jpg");
				move_uploaded_file( $_FILES['header']['tmp_name'],$jshopConfig->path . "images/header.jpg");	
			}
		}
	
		if (isset($_FILES['footer'])){
			if ($_FILES['footer'][size]){
				@unlink($jshopConfig->path . "images/footer.jpg");
				move_uploaded_file( $_FILES['footer']['tmp_name'],$jshopConfig->path . "images/footer.jpg");
			}	
		}
	    
	    if ($tab==4){
            $_lang = &$this->getModel("languages");
            $languages = $_lang->getAllLanguages(1);
		    foreach ($languages as $lang) {
                
                $description = JRequest::getVar('description'.$lang->id,'','post',"string", 2);
                $agb = JRequest::getVar('agb'.$lang->id,'','post',"string", 2);
                $return_policy = JRequest::getVar('return_policy'.$lang->id,'','post',"string", 2);
                $order_email_descr = JRequest::getVar('order_email_descr'.$lang->id,'','post',"string", 2);
                $order_finish_descr = JRequest::getVar('order_finish_descr'.$lang->id,'','post',"string", 2);
                $shipping = JRequest::getVar('shipping'.$lang->id,'','post',"string", 2);
                
			    $query = "REPLACE INTO `#__jshopping_config_main_page`
					      SET `language` = '" . $lang->language . "', 
                          `description` = '" . $db->getEscaped($description) . "', 
                          `meta_title` = '" . $db->getEscaped($post['meta_title'][$lang->language]) . "', 
                          `meta_description` = '" . $db->getEscaped($post['meta_description'][$lang->language]) . "', 
                          `meta_keyword` = '" . $db->getEscaped($post['meta_keyword'][$lang->language]) . "', 
                          `agb` = '" . $db->getEscaped($agb) . "', 
                          `return_policy` = '" . $db->getEscaped($return_policy) . "',
                          `shipping` = '" . $db->getEscaped($shipping) . "',
                          `order_finish_descr` = '" . $db->getEscaped($order_finish_descr) . "',
                          `order_email_descr` = '".$db->getEscaped($order_email_descr)."'";
			    $db->setQuery($query);
			    $db->query();
			    
		    }
	    }
        
        if ($this->getTask()=='apply'){            
            switch ($tab){
                case 1: $task = "general"; break;
                case 2: $task = "currency"; break;
                case 3: $task = "image"; break;
                case 4: $task = "mainpage"; break;
                case 5: $task = "storeinfo"; break;
                case 6: $task = "catprod"; break;
                case 7: $task = "checkout"; break;
                case 8: $task = "adminfunction"; break;
            }
            $this->setRedirect('index.php?option=com_jshopping&controller=config&task='.$task, _JSHOP_CONFIG_SUCCESS);
        }else{
		    $this->setRedirect('index.php?option=com_jshopping&controller=config', _JSHOP_CONFIG_SUCCESS);
        }
    }
    
    function preview_pdf(){
		$jshopConfig = &JSFactory::getConfig();
        $jshopConfig->currency_code = "USD";
		require_once(JPATH_SITE . "/components/com_jshopping/lib/generete_pdf_order.php");
        $order->firma_name = "Firma";
        $order->f_name = "Fname";
        $order->l_name = 'Lname';
        $order->street = 'Street';
        $order->zip = "Zip"; 
        $order->city = "City";
        $order->country = "Country";
        $order->order_number = outputDigit(0,8);
        $order->order_date = strftime($jshopConfig->store_date_format, mktime());
        $order->products = array();
        $prod = new stdClass();
        $prod->product_name = "Product name";
        $prod->product_ean = "12345678";
        $prod->product_quantity = 1;
        $prod->product_item_price = 125;
        $prod->product_tax = 19;
        $order->products[] = $prod;
        $order->order_subtotal = 125;
        $order->order_shipping = 20;
        $order->order_tax_list = array(19 => 23.15);
        $order->order_total = 145;
		$order->pdf_file = generatePdf($order, $jshopConfig);
		header("Location: " . $jshopConfig->pdf_orders_live_path . "/" . $order->pdf_file);
		die();
	}
    
    function check_directory() {
        $directory = JRequest::getVar('directory');
        $jshopConfig = &JSFactory::getConfig();
        if (is_writable($jshopConfig->path . "/" . $directory)){
            print '{ "isWrite" : "1", "text" : "' . _JSHOP_WRITEABLE . '" }';
        }else{
            print '{ "isWrite" : "0", "text" : "' . _JSHOP_NON_WRITEABLE . '"}';
        }
        die();        
    }
    
    
    
}

?>